﻿using Android.App;
using Android.Widget;
using Android.OS;
using Com.Syncfusion.Charts;
using Android.Views;
using Android.Graphics;
using Com.Syncfusion.Charts.Enums;
using System;

namespace DataMarker
{
    [Activity(Label = "DataMarker", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
        ChartObservableArrayList DataPoints1;
        ChartObservableArrayList DataPoints2;
        ChartObservableArrayList DataPoints3;
        ChartObservableArrayList DataPoints4;

        LinearLayout layout;
        TextView label;
        ImageView image;

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            SfChart chart = new SfChart(this);
            chart.SetBackgroundColor(Color.White);

            DataPoints1 = new ChartObservableArrayList();
            DataPoints1.Add(new ChartDataPoint("2006", 28));
            DataPoints1.Add(new ChartDataPoint("2007", 25));
            DataPoints1.Add(new ChartDataPoint("2008", 30));
            DataPoints1.Add(new ChartDataPoint("2009", 28));
            DataPoints1.Add(new ChartDataPoint("2010", 32));
            DataPoints1.Add(new ChartDataPoint("2011", 35));
            DataPoints1.Add(new ChartDataPoint("2012", 30));

            DataPoints2 = new ChartObservableArrayList();
            DataPoints2.Add(new ChartDataPoint("2006", 32));
            DataPoints2.Add(new ChartDataPoint("2007", 28));
            DataPoints2.Add(new ChartDataPoint("2008", 32));
            DataPoints2.Add(new ChartDataPoint("2009", 36));
            DataPoints2.Add(new ChartDataPoint("2010", 34));
            DataPoints2.Add(new ChartDataPoint("2011", 38));
            DataPoints2.Add(new ChartDataPoint("2012", 37));

            DataPoints3 = new ChartObservableArrayList();
            DataPoints3.Add(new ChartDataPoint("2006", 36));
            DataPoints3.Add(new ChartDataPoint("2007", 34));
            DataPoints3.Add(new ChartDataPoint("2008", 33));
            DataPoints3.Add(new ChartDataPoint("2009", 38));
            DataPoints3.Add(new ChartDataPoint("2010", 40));
            DataPoints3.Add(new ChartDataPoint("2011", 41));
            DataPoints3.Add(new ChartDataPoint("2012", 39));

            DataPoints4 = new ChartObservableArrayList();
            DataPoints4.Add(new ChartDataPoint("2006", 38));
            DataPoints4.Add(new ChartDataPoint("2007", 36));
            DataPoints4.Add(new ChartDataPoint("2008", 40));
            DataPoints4.Add(new ChartDataPoint("2009", 44));
            DataPoints4.Add(new ChartDataPoint("2010", 46));
            DataPoints4.Add(new ChartDataPoint("2011", 47));
            DataPoints4.Add(new ChartDataPoint("2012", 45));

            CategoryAxis xAxis = new CategoryAxis();
            xAxis.LabelPlacement = LabelPlacement.BetweenTicks;
            chart.PrimaryAxis = xAxis;

            NumericalAxis yAxis = new NumericalAxis();
            chart.SecondaryAxis = yAxis;

            LineSeries series1 = new LineSeries();
            series1.DataSource = DataPoints1;
            series1.DataMarker.ShowLabel = true;
            series1.DataMarker.ShowMarker = true;
            series1.DataMarkerLabelCreated += Series1_DataMarkerLabelCreated;
            chart.Series.Add(series1);

            LineSeries series2 = new LineSeries();
            series2.DataSource = DataPoints2;
            series2.DataMarker.ShowLabel = true;
            series2.DataMarker.ShowMarker = true;
            series2.DataMarkerLabelCreated += Series2_DataMarkerLabelCreated;
            chart.Series.Add(series2);

            LineSeries series3 = new LineSeries();
            series3.DataSource = DataPoints3;
            series3.DataMarker.ShowLabel = true;
            series3.DataMarker.ShowMarker = true;
            series3.DataMarkerLabelCreated += Series3_DataMarkerLabelCreated;
            chart.Series.Add(series3);

            LineSeries series4 = new LineSeries();
            series4.DataSource = DataPoints4;
            series4.DataMarker.ShowLabel = true;
            series4.DataMarker.ShowMarker = true;
            series4.DataMarkerLabelCreated += Series4_DataMarkerLabelCreated;
            chart.Series.Add(series4);

            SetContentView(chart);
        }

        private void Series1_DataMarkerLabelCreated(object sender, ChartSeries.DataMarkerLabelCreatedEventArgs e)
        {
            layout = new LinearLayout(this);
            layout.Orientation = Android.Widget.Orientation.Horizontal;
            label = new TextView(this);
            label.SetTextColor(Color.Black);
            image = new ImageView(this);
            image.LayoutParameters = new ViewGroup.LayoutParams(new LinearLayout.LayoutParams(30, 30));

            if (e.P0.Index == DataPoints1.Size() - 1)
            {
                image.SetImageResource(Resource.Drawable.Icon);
                label.Text = e.P0.Label;
            }

            layout.AddView(label);
            layout.AddView(image);
            e.P0.View = layout;
        }

        private void Series2_DataMarkerLabelCreated(object sender, ChartSeries.DataMarkerLabelCreatedEventArgs e)
        {
            layout = new LinearLayout(this);
            layout.Orientation = Android.Widget.Orientation.Horizontal;
            label = new TextView(this);
            label.SetTextColor(Color.Black);
            image = new ImageView(this);
            image.LayoutParameters = new ViewGroup.LayoutParams(new LinearLayout.LayoutParams(30, 30));

            if (e.P0.Index == DataPoints2.Size() - 1)
            {
                image.SetImageResource(Resource.Drawable.Icon);
                label.Text = e.P0.Label;
            }

            layout.AddView(label);
            layout.AddView(image);
            e.P0.View = layout;
        }

        private void Series3_DataMarkerLabelCreated(object sender, ChartSeries.DataMarkerLabelCreatedEventArgs e)
        {
            layout = new LinearLayout(this);
            layout.Orientation = Android.Widget.Orientation.Horizontal;
            label = new TextView(this);
            label.SetTextColor(Color.Black);
            image = new ImageView(this);
            image.LayoutParameters = new ViewGroup.LayoutParams(new LinearLayout.LayoutParams(30, 30));

            if (e.P0.Index == DataPoints3.Size() - 1)
            {
                image.SetImageResource(Resource.Drawable.Icon);
                label.Text = e.P0.Label;
            }
         
            layout.AddView(label);
            layout.AddView(image);
            e.P0.View = layout;
        }

        private void Series4_DataMarkerLabelCreated(object sender, ChartSeries.DataMarkerLabelCreatedEventArgs e)
        {
            layout = new LinearLayout(this);
            layout.Orientation = Android.Widget.Orientation.Horizontal;
            label = new TextView(this);
            label.SetTextColor(Color.Black);
            image = new ImageView(this);
            image.LayoutParameters = new ViewGroup.LayoutParams(new LinearLayout.LayoutParams(30, 30));

            if (e.P0.Index == DataPoints4.Size() - 1)
            {
                image.SetImageResource(Resource.Drawable.Icon);
                label.Text = e.P0.Label;
            }

            layout.AddView(label);
            layout.AddView(image);
            e.P0.View = layout;
        }
    }
}

